VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form SimpleClient 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SimpleChat Client"
   ClientHeight    =   6495
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7395
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "SimpleClient.frx":0000
   LinkTopic       =   "SimpleClient"
   MaxButton       =   0   'False
   ScaleHeight     =   6495
   ScaleWidth      =   7395
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrDisconnectCleanup 
      Enabled         =   0   'False
      Interval        =   333
      Left            =   3960
      Top             =   1680
   End
   Begin MSWinsockLib.Winsock wskClient 
      Left            =   3000
      Top             =   1680
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Frame Frame2 
      Caption         =   "Chat"
      Height          =   4335
      Left            =   60
      TabIndex        =   9
      Top             =   2100
      Width           =   7275
      Begin VB.TextBox txtInput 
         Height          =   315
         Left            =   120
         TabIndex        =   5
         Top             =   3840
         Width           =   7035
      End
      Begin VB.TextBox txtLog 
         BackColor       =   &H8000000F&
         Height          =   3555
         Left            =   120
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   2  'Vertical
         TabIndex        =   10
         TabStop         =   0   'False
         Top             =   240
         Width           =   7035
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Client Control"
      Height          =   1515
      Left            =   60
      TabIndex        =   6
      Top             =   120
      Width           =   7275
      Begin VB.TextBox txtServer 
         Height          =   345
         Left            =   3060
         TabIndex        =   1
         Top             =   300
         Width           =   2775
      End
      Begin VB.TextBox txtName 
         Height          =   345
         Left            =   3060
         TabIndex        =   2
         Top             =   960
         Width           =   1575
      End
      Begin VB.TextBox txtPort 
         Alignment       =   1  'Right Justify
         Height          =   345
         Left            =   600
         TabIndex        =   0
         Top             =   300
         Width           =   795
      End
      Begin VB.CommandButton cmdConnect 
         Caption         =   "Connect"
         Default         =   -1  'True
         Height          =   375
         Left            =   6120
         TabIndex        =   3
         Top             =   300
         Width           =   975
      End
      Begin VB.CommandButton cmdStop 
         Caption         =   "Stop"
         Height          =   375
         Left            =   6120
         TabIndex        =   4
         Top             =   960
         Width           =   975
      End
      Begin VB.Label Label3 
         Alignment       =   1  'Right Justify
         Caption         =   "Server name/IP:"
         Height          =   255
         Left            =   1560
         TabIndex        =   11
         Top             =   360
         Width           =   1455
      End
      Begin VB.Label Label2 
         Alignment       =   1  'Right Justify
         Caption         =   "Your name:"
         Height          =   255
         Left            =   1920
         TabIndex        =   8
         Top             =   1020
         Width           =   1095
      End
      Begin VB.Label Label1 
         Alignment       =   1  'Right Justify
         Caption         =   "Port:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   360
         Width           =   435
      End
   End
End
Attribute VB_Name = "SimpleClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'SimpleChat
'==========
'
'Tiny multiuser chat client using TCP via Winsock
'controls.  Designed to demonstrate proper message
'framing and Winsock event handling.
'

Private Const MESSAGE_DELIMITER As String = vbFormFeed
Private Const DEFAULT_PORT As Long = 8765
Private Const BUFFER_MAX As Long = 20000
Private Const BUFFER_FALLBACK As Long = 18000

'Incoming stream assembly buffer.
Private strBuffer As String

Private Sub DisconnectCleanup()
    wskClient.LocalPort = 0
    cmdStop.Enabled = False
    cmdConnect.Enabled = True
    txtPort.Enabled = True
    txtServer.Enabled = True
    txtName.Enabled = True
    txtInput.Text = ""
    txtInput.Enabled = False
    txtPort.SetFocus
End Sub

Private Sub Log(ByVal Text As String)
    With txtLog
        .SelStart = Len(.Text)
        .SelText = Text & vbNewLine
        .SelStart = Len(.Text)
    End With
End Sub

Private Sub ProcessMessages()
    Dim strMessages() As String
    Dim lngMsgLast As Long
    Dim lngMsg As Long
    
    'Parse messages from buffer.
    strMessages = Split(strBuffer, MESSAGE_DELIMITER)
    lngMsgLast = UBound(strMessages)
    
    'Process whole messages.
    For lngMsg = 0 To lngMsgLast - 1
        Log strMessages(lngMsg)
    Next
    
    'Put any remainder back in the buffer.
    If lngMsgLast > 0 Then
        strBuffer = strMessages(lngMsgLast)
    End If
End Sub

Private Sub cmdConnect_Click()
    Dim strPort As String
    Dim lngPort As Long
    
    strPort = txtPort.Text
    If IsNumeric(strPort) Then
        lngPort = CLng(strPort)
        If 0 < lngPort And lngPort < 65636 Then
            If Len(txtServer.Text) > 0 Then
                If Len(txtName.Text) > 0 Then
                    wskClient.Connect txtServer.Text, lngPort
                    txtPort.Enabled = False
                    txtServer.Enabled = False
                    txtName.Enabled = False
                    cmdConnect.Enabled = False
                    cmdStop.Enabled = True
                    Log "Connecting on port " & CStr(lngPort)
                    Exit Sub
                Else
                    MsgBox "Your name is required", vbOKOnly, App.Title
                    txtName.SetFocus
                    Exit Sub
                End If
            Else
                MsgBox "Server name or IP address required", vbOKOnly, App.Title
                txtServer.SetFocus
                Exit Sub
            End If
        Else
            MsgBox "Port must be from 1 to 65535", vbOKOnly, App.Title
        End If
    Else
        MsgBox "Port must be numeric", vbOKOnly, App.Title
    End If
    txtPort.SetFocus
End Sub

Private Sub cmdStop_Click()
    Log "Closing connection"
    wskClient.Close
    tmrDisconnectCleanup.Enabled = True
End Sub

Private Sub Form_Load()
    txtPort.Text = CStr(DEFAULT_PORT)
    cmdStop.Enabled = False
    txtInput.Enabled = False
End Sub

Private Sub tmrDisconnectCleanup_Timer()
    'When the user clicks cmdStop we close our end of
    'the TCP connection, arm this timer, and check
    'every 1/3 second for the server to close his end.
    
    If wskClient.State = sckClosed Then
        tmrDisconnectCleanup.Enabled = False
        DisconnectCleanup
    End If
End Sub

Private Sub txtInput_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        wskClient.SendData txtName.Text & ": " & txtInput.Text & MESSAGE_DELIMITER
        txtInput.Text = ""
        KeyAscii = 0
    End If
End Sub

Private Sub wskClient_Close()
    Log "Server closed connection"
    wskClient.Close
    DisconnectCleanup
End Sub

Private Sub wskClient_Connect()
    Log "Connected"
    txtInput.Enabled = True
    txtInput.SetFocus
End Sub

Private Sub wskClient_DataArrival(ByVal bytesTotal As Long)
    Dim strFragment As String
    
    'Get TCP stream fragments, assemble into appropriate buffer.
    With wskClient
        Do While .BytesReceived > 0
            .GetData strFragment, vbString
            If Len(strBuffer) > BUFFER_MAX Then
                strBuffer = Left$(strBuffer, BUFFER_FALLBACK) & strFragment
            Else
                strBuffer = strBuffer & strFragment
            End If
        Loop
    End With
    
    'Check for any complete messages, if found process them.
    If InStrRev(strBuffer, MESSAGE_DELIMITER) > 0 Then
        ProcessMessages
    End If
End Sub

Private Sub wskClient_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    Log "Error " & CStr(Number) & ": " & Description
    Log "Closing connection"
    wskClient.Close
    DisconnectCleanup
End Sub
